from __future__ import print_function

from ctypes import *
import sys

def main(argv):
    """
    see https://stackoverflow.com/questions/15472217/python-ctypes-exception-access-violation-reading
    """
    
    dict_name = argv[1]
    if len(argv) > 2:
        dll_name = argv[2]
    else:
        dll_name = 'libhunspell.dll'

    mydll = CDLL(dll_name)
    mydll.Hunspell_create.argtypes = [c_char_p, c_char_p]
    mydll.Hunspell_create.restype  = c_void_p
    
    mydll.Hunspell_destroy.argtypes = [c_void_p]
    mydll.Hunspell_destroy.restype  = None

    mydll.Hunspell_get_dic_encoding.argtypes = [c_void_p]
    mydll.Hunspell_get_dic_encoding.restype  = c_char_p
    
    hunspell = mydll.Hunspell_create(
                        create_string_buffer(bytes(dict_name+".aff", "utf-8")),
                        create_string_buffer(bytes(dict_name+".dic", "utf-8")))
    print(mydll.Hunspell_get_dic_encoding(hunspell))
    
    mydll.Hunspell_destroy(hunspell)
    return 0
    
if __name__ == "__main__":
    exit(main(sys.argv))
